#!/bin/sh
# $Id: t-auth-0.sh,v 1.3 2008/11/07 03:42:56 ca Exp $
#
# ----------------------------------------
# test AUTH= parameter
# ----------------------------------------
#
test -s stop && exit 1
#

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh
ERRS=0

if ../smtps/smtps -VVV | ${GREP} MTA_TEST_SASL >/dev/null
then
  :
else
  echo "SKIPPED: $0: smtps not compiled with MTA_TEST_SASL"
  exit 0
fi
SKIP=""

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# clean up before running tests
cd ../qmgr || exit 1
rm -f ${MTMAP} ${QMGRCONFMAP} ${ACCMAP} ${ALIMAP}

# create aliases
${CAT} > ${ALI} <<EOF
postmaster:	local:
user:	local:
EOF
# create map
rm -f ${ALIMAP}
${MM} < ${ALI}

# create mailertable (save old version?)
${CAT} > ${MT} <<EOF
local.dom	[127.0.0.1]
other.dom	[127.1.2.3]
EOF

TEST=1
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
if ${SHELL} ${SD}/smtp1.sh -Ssender@other.dom -Ruser@local.dom -Z smtpc2 -c '-M AUTH=sender@other.domain'
then
  if grep 'func=ss_mail_args, .*, auth=sender@other.domain' ${SSL} >/dev/null
  then
    :
  else
    ERR=true
  fi
else
  ERR=true
fi
fi

TEST=2
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
if ${SHELL} ${SD}/smtp1.sh -Ssender@other.dom -Ruser@local.dom -Z smtpc2 -c '-M AUTH=bogus+ext@other.domain' -E 0 -X 0 -A 0
then
  if grep 'func=ss_mail_args, .*, auth=' ${SSL} >/dev/null
  then
    ERR=true
  else
    if grep 'func=ss_mail, .*, status=5.*Invalid.*AUTH' ${SSL} >/dev/null
    then
      :
    else
      ERR=true
    fi
  fi
else
  ERR=true
fi
fi


if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi

exit ${ERRS}
