#!/bin/sh
# $Id: t-cdbbase-0.sh,v 1.1 2007/11/30 05:51:37 ca Exp $
#
# ----------------------------------------
# test program running the full system, uses mcpmts.sh
# test CDB_base_directory
# ----------------------------------------
#
test -s stop && exit 1
#

# source directory of this (and other) shell script
SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

SSPASSFDDIR=smtps

cd .. || exit 1
BD=`pwd`
# cd to right directory
cd qmgr >/dev/null || exit 1
CDB1="MeTA1"
test -d ${CDB1} || mkdir ${CDB1}
cd ${CDB1} >/dev/null || exit 1
CDBBD=`pwd`
MTA_CDB_BASE_DIR=${CDBBD}"/"
export MTA_CDB_BASE_DIR

# create necessary directories
for i in ${SSPASSFDDIR}
do
  test -d $i || mkdir $i
done

cd ..
rm -f ${MTMAP}

SHELL=/bin/sh
test -x /bin/ksh && SHELL=/bin/ksh

# ----------------------------------------
${CAT} >${SMXCNF} <<EOF
CDB_base_directory="${CDBBD}/";
smtps { log_level = 12;
	pass_fd_socket = "${SSPASSFDDIR}/smtpsfd";
	wait_for_server=4;
	listen_socket { type=inet; port=${SRVPORT}; }
	start_action = pass; user = ${USER};
	path = "${BD}/smtps/smtps";
	arguments = "smtps -f ${SMXCNF} ${MTA_SERVER_OPTIONS}";
}
smtpc { log_level = 12;remote_port = ${SNKPORT}; wait_for_server=4;
	start_action = wait; user = ${USER};
	path = "${BD}/smtpc/smtpc"; arguments = "smtpc -f ${SMXCNF}";
}
qmgr { log_level = 12;wait_for_server=4; wait_for_client=4; 
	start_action = wait; user = ${USER};
	restart_dependencies = { smtps,smtpc,smar, };
	path = "${BD}/qmgr/qmgr"; arguments = "qmgr -f ${SMXCNF}";
}
smar { log_level = 12;
	start_action = wait; user = ${USER};
	restart_dependencies = { smtps,qmgr };
	path = "${BD}/smar/smar"; arguments = "smar -f ${SMXCNF}";
}
EOF

for i in smar smtps smtpc qmgr
do
  cp /dev/null ${i}.log
done

# ----------------------------------------
${SHELL} ${SD}/mcpmts.sh -1 $@ || exit $?

rm -rf ${CDB1}
unset MTA_CDB_BASE_DIR

exit 0
