/*
 * Copyright (c) 2004, 2005 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: compoptions.c,v 1.5 2006/11/05 17:16:56 ca Exp $")
#include "sm/error.h"
#include "sm/assert.h"
#include "sm/evthr.h"
#include "sm/io.h"

/*
**  EVTHR_COMPOPTIONS -- return compile time options
**
**	Parameters:
**		evthr_ctx -- evthr context (currently unused)
**		fp -- file for output
**
**	Returns:
**		usual sm_error code
*/

sm_ret_T
evthr_comptoptions(sm_evthr_ctx_P evthr_ctx, sm_file_T *fp)
{
#if 0
	SM_IS_EVTHR_CTX(evthr_ctx);
#endif
	sm_io_fprintf(fp,
#if EVTHR_DEBUG
		"EVTHR_DEBUG\n"
#endif
#if EVTHR_PARANOIA
		"EVTHR_PARANOIA\n"
#endif
#if SM_LOCK_TASK
		"SM_LOCK_TASK\n"
#endif
		"EVTHR_PRIOS=" SM_XSTR(EVTHR_PRIOS) "\n"
		);
	return SM_SUCCESS;
}
